#include "headio.h"
#include "Headped.H"
#include <stdlib.h>
void resetgens(void),setindcoords(struct ind *,float);
extern int someown(struct ind *);

void mngrcoords(void)
/*
   Assigns coordinates for a marriage node graph of the pedigree.
*/
{
  /* for reordering marriages of marstack & inds of instack */
  struct mar **marstack_ptr_vec;  /* vector of pointers to the marriages of marstack */
  struct ind **indstack_ptr_vec;  /* vector of pointers to the inds of instack */
		/* new order by coordinates: left to right, top to bottom */
  int *in_marstack_new, *in_indstack_new;
  int marstack_last = 0, indstack_last = 0;

  int i, j, k, *nbmar, *nbind, first, a, count;
  float yunit = .5/higen, tot, big;
  struct marlist *ml;
  struct ind *spouse;

  marstack_ptr_vec = (struct mar **)calloc(marpt+1,sizeof(struct mar *));
  indstack_ptr_vec = (struct ind **)calloc(indpt+1,sizeof(struct ind *));
  in_marstack_new = (int *)calloc(marpt+1,sizeof(int));
  in_indstack_new = (int *)calloc(indpt+1,sizeof(int));
  nbmar = (int *)calloc(higen,sizeof(int));
  nbind = (int *)calloc(higen+1,sizeof(int));

  resetgens();		/* adjusts generation numbers of individuals */
  
  
  /* enter the first level marriages into marstack and set their coords */
  for(i=1; i<= marpt; i++) if((!in_marstack_new[i]) &&
    (MAXIMUM(marstack[i].pa->info.gen,marstack[i].ma->info.gen)==1)){
      ++marstack_last;
      marstack_ptr_vec[marstack_last] = &marstack[i];
      in_marstack_new[i] = 1;
      ++nbmar[1];
      marstack[i].info.ycoord = 1- 1./((float) higen);
      marstack[i].info.xcoord = nbmar[1];
  }
  for(i=1;i<=nbmar[1];i++) marstack_ptr_vec[i]->info.xcoord /= nbmar[1]+1.;
  
  /* enter the first level of individuals */
  for (i=1; i<=indpt; ++i) if((!in_indstack_new[i]) && (indstack[i].info.gen == 1)){
      nbind[1]++;
      indstack_last++;
      in_indstack_new[i] = 1;
      /* compute xcoord as average of its marriages */
      for (count=0,tot=0.0,big = 0.0,  ml = indstack[i].own; ml != nomarlist; ml = ml->next) 
        if (MAXIMUM(ml->cur->ma->info.gen,ml->cur->pa->info.gen) == 1)
	{ tot += ml->cur->info.xcoord; 
          if (big < ml->cur->info.ycoord) big = ml->cur->info.ycoord;
	  ++count;	}
      if(count == 0) printf("ind of gen 0 has no marriage in level 1!!!\n");
      else{ 
        indstack[i].info.xcoord = tot/count; 
	indstack[i].info.ycoord = big + yunit;
      }
      /* sort the individual into indstack_ptr_vec */
      j=1; 
      while((j<indstack_last)&&
            (indstack[i].info.xcoord>=indstack_ptr_vec[j]->info.xcoord)) j++;
      for(k=indstack_last;k>j; k--) indstack_ptr_vec[k] = indstack_ptr_vec[k-1];
      indstack_ptr_vec[j] = &indstack[i];
  }
  for(i=1;i<=indstack_last;i++)
    indstack_ptr_vec[i]->info.xcoord = i/((float)(nbind[1]+1));

  for(a=2;a<=higen;a++){
      /* place non-founder inds on generation level a */
      first = indstack_last+1;	/* first ind on level a */
      for (i=1; i<=indpt; ++i) if((!in_indstack_new[i]) && (indstack[i].info.gen == a))
	if(indstack[i].par != nomar){
	  nbind[a]++;
	  indstack_last++;
	  in_indstack_new[i] = 1;
	  indstack[i].info.xcoord = indstack[i].par->info.xcoord;
  	  indstack[i].info.ycoord = indstack[i].par->info.ycoord - yunit;
	  j=first;
	  while((j<indstack_last)&&
        	(indstack[i].info.xcoord>=indstack_ptr_vec[j]->info.xcoord)) j++;
	  for(k=indstack_last;k>j; k--) indstack_ptr_vec[k] = indstack_ptr_vec[k-1];
	  indstack_ptr_vec[j] = &indstack[i];
      }
      /* place founder inds on generation level a */
      for (i=1; i<=indpt; ++i) if((!in_indstack_new[i]) && (indstack[i].info.gen == a))
	if(indstack[i].par == nomar){
	  nbind[a]++;
	  indstack_last++;
	  in_indstack_new[i] = 1;
	  /* spouse is the partner in the first marriage */
	  if(indstack[i].info.name==indstack[i].own->cur->pa->info.name)
	    { spouse = indstack[i].own->cur->ma; }
	  else if(indstack[i].info.name==indstack[i].own->cur->ma->info.name)
	    { spouse = indstack[i].own->cur->pa; }
	  else printf("ind is not a spouse in its own marriage!");
	  spouse = (indstack[i].info.name==indstack[i].own->cur->pa->info.name) ?
	            indstack[i].own->cur->ma : indstack[i].own->cur->pa; 
          j=first; while((j<indstack_last)&&(indstack_ptr_vec[j]->info.name != spouse->info.name)) j++;
	  for(k=indstack_last;k>j; k--) indstack_ptr_vec[k] = indstack_ptr_vec[k-1];
	  indstack_ptr_vec[j] = &indstack[i];
	  indstack[i].info.ycoord = 1-(float)a/((float)higen) + yunit; /*spouse->info.ycoord;*/
      }	
	
      tot = 1./((float)(nbind[a]+1));
      for(i=first;i<=indstack_last;i++)
	indstack_ptr_vec[i]->info.xcoord = (i-first+1)*tot;

      if(a == higen) break;
      /* place marriages on gen level a */
      first = marstack_last+1;	/* first marriage on level a */
      for(i=1; i<= marpt; i++) if((!in_marstack_new[i])&&
	(MAXIMUM(marstack[i].pa->info.gen,marstack[i].ma->info.gen)==a)){
	++nbmar[a];
	in_marstack_new[i] = 1;
	marstack[i].info.xcoord = .5*(marstack[i].pa->info.xcoord +
      				      marstack[i].ma->info.xcoord);
	marstack[i].info.ycoord =  1.0 - ((float)a)/higen;
	++marstack_last;
	j=first;
	while((j<marstack_last)&&
              (marstack[i].info.xcoord>=marstack_ptr_vec[j]->info.xcoord)) j++;
	for(k=marstack_last;k>j;k--) marstack_ptr_vec[k] = marstack_ptr_vec[k-1];
	marstack_ptr_vec[j] = &marstack[i];
      }
  }
}

