#include "headio.h"
#include "Headped.H"

/*================================*/
/* Stacks for pedigree structures */
/*================================*/

/*=================*/
/* Null locations. */
/*=================*/

struct ind *noind = NULL ;
struct mar *nomar ;
struct indlist  *noindlist = NULL ;
struct marlist  *nomarlist = NULL ;

/*=============================*/
/* Maximum storage parameters. */
/*=============================*/

int maxind,       /* most individuals allowed */ 
    maxmar,       /* most marriages allowed */
    maxindlist,
    maxlabel, 
    maxmarlist;

/*================*/
/* Storage stacks */
/*================*/

struct ind **ped;              /* pointers to all individuals */

struct ind *indstack;          /* array of all individuals */
struct mar *marstack;          /* array of all marriages */
struct marlist *marliststack;
struct indlist *indliststack;


/*=================*/
/* Stack pointers. */
/*=================*/

int indpt=0,       /* number of individuals */
    marpt=0,       /* number of marriages */
    indlistpt=0, 
    marlistpt=0; 

/*================*/
/* Status markers */
/*================*/

int hilabel=0,    /* highest number used as an individual's name */
    higen=0,      /* highest generation in pedigree */
    ncomp=0,      /* number of distinct components in the pedigree */
    coordset=0,   /* set to 1 if marriage node graph coordinates are set */
    genreset=0,   /* set to 1 if the generations have been reset */
    pedset=0;     /* set to 1 if the pedigree has been read in */
