#include <cstdlib>
#include <cstring>
#include "pfiddler.h"
#include "headio.h"
#include "util.h"

using namespace std;

#include "simanneal.h"
#include <FL/Fl_Menu_Bar.H>

void print_it();
void eps_it();
void simanneal_it();
bool txt2pedc_it(char *);
Drawing *d;

char pedname[maxstr];
void openpedc(int ppk);
bool pedcopen;
int flag_cb;
int pinkish = 0;

float xmax, xmin;
float ymax=1, ymin=0;

void quit_cb(Fl_Widget *, void *){
  exit(0);
}

void save_cb(Fl_Widget *, void *){
  if(pedcopen){
    FILE *file;
    if((file = fopen(pedname,"w")) == NULL){
      fl_alert(" Unable to open %s ",pedname);
      return;
    }
    outputpedc(file,pedname,0);
    fclose(file);
  }
}

void open_cb(Fl_Widget *wm, void *pp){
  int ppk = *(int *)pp;
  if(!pedcopen){
    const char *r = fl_file_chooser("File name", "*.pedc",NULL);
    if(r){
      strcpy(pedname,r);
      openpedc(ppk);
      wm->redraw();
    }
  }
}

void alias_cb(Fl_Widget *, void *){
  char alia[256];
  if(pedcopen){
    const char *r = fl_file_chooser("File name", "*.txt",NULL);
    if(r){
      strcpy(alia,r);
      aliases(alia);
    }
  }
}

void print_cb(Fl_Widget *, void *){
  if(pedcopen) print_it();
}

void eps_cb(Fl_Widget *, void *){
  if(pedcopen) eps_it();
}

void simanneal_cb(Fl_Widget*, void *){
  if(pedcopen) simanneal_it();
}

void saveas_cb(Fl_Widget *, void *pp){
  int ppk = *(int *)pp;
  if(pedcopen){
    const char *r = fl_file_chooser("File name", "*.pedc",NULL);
    if(r){
      FILE *file;
      if((file = fopen(r,"w")) == NULL){
	fl_alert(" Unable to open %s ",r);
	return;
      }
      strcpy(pedname,r);
      outputpedc(file,pedname,ppk);
      fclose(file);
    }
  }
}

extern int rowmov;
void grmode_cb(Fl_Widget *w, void *v){
  rowmov = *(int *)v;
  return;
}

void tidy_cb(Fl_Widget *w, void *){
  bckpcoords bak;
  bak.copy();
  tidycoord();
  d->hide();
  d->show();
  if(!fl_choice("Do you like it?","No","Yes",0L)){
    bak.unset();
    d->hide();
    d->show();
  }
  return;
}

void align_cb(Fl_Widget *w, void *){
  align();
  d->hide();
  d->show();
  return;
}
  
void zap_cb(Fl_Widget *w, void *v){
  flag_cb = *(int *)v;
  fl_cursor((Fl_Cursor)45);
  return;
}

void wipe_cb(Fl_Widget *, void *){
  wipelabels();
}

void color_cb(Fl_Widget *w, void *v){
  flag_cb = *(int *)v;
  if(flag_cb == 0){
    uchar r=255,g=255,b=255;
    if(fl_color_chooser("Select color",r,g,b)){
      for (int i=1; i<=indpt; i++)
	if (indstack[i].info.flag != GONE){
	  indstack[i].info.r = r;
	  indstack[i].info.g = g;
	  indstack[i].info.b = b;
	}
    }
  }else{
    if(flag_cb == 11){
      flag_cb = 0;
      for (int i=1; i<=indpt; i++)
	if (indstack[i].info.flag == HIDDEN)
	  indstack[i].info.flag = UP;
    }
  }
  if(flag_cb) fl_cursor(FL_CURSOR_CROSS);
  return;
}
void txt2pedc_cb(Fl_Widget *, void *);

static int cero =0, uno = 1, dos = 2, tres = 3, cuatro = 4,
  cinco = 5, seis = 6, siete = 7, ocho = 8, nueve = 9,
  diez = 10, once = 11;

Fl_Menu_Item maintable[]={
  {"&File",FL_Escape,0,0,FL_SUBMENU},
  {"&Open", FL_ALT+'o', open_cb, (void *)&cero},
  {"Import",0,0,0,FL_SUBMENU},
  {"Pedpac&k", FL_ALT+'k', open_cb, (void *)&uno},
  {"&Text", FL_ALT+'t', txt2pedc_cb, 0},
  {0},
  {"&Save", FL_ALT+'s', save_cb, 0, FL_MENU_INACTIVE},
  {"Save &As", FL_ALT+'A', saveas_cb,(void *)&cero, FL_MENU_INACTIVE},
  {"E&xport pedpack", FL_ALT+'x', saveas_cb,(void *)&uno, FL_MENU_INACTIVE},
  {"Import &Labels",FL_ALT+'L', alias_cb,0, FL_MENU_INACTIVE|FL_MENU_DIVIDER},
  {"Make &Eps",FL_ALT+'E', eps_cb, 0, FL_MENU_INACTIVE},
#ifndef WIN32
  {"&Print", FL_ALT+'p', print_cb, 0,  FL_MENU_INACTIVE|FL_MENU_DIVIDER},
#endif
  {"&Quit", FL_ALT+'q', quit_cb},
  {0},
  {"&Edit",0,0,0, FL_MENU_INACTIVE|FL_SUBMENU},
  {"Remove",0,0,0,FL_SUBMENU},
  {"&family",FL_ALT+'z',zap_cb,(void *)&uno, 0},
  {"&individual",FL_ALT+'i',zap_cb,(void *)&dos, 0},
  {"maria&ge",FL_ALT+'g',zap_cb,(void *)&tres, 0},
  {0},
  {"Colours",0,0,0,FL_SUBMENU},
  {"Se&t all",FL_ALT+'t',color_cb,(void *)&cero, 0},
  {"Drop &downward",FL_ALT+'d',color_cb,(void *)&cuatro, 0},
  {"Drop &upward",FL_ALT+'u',color_cb,(void *)&cinco, 0},
  {"Or dow&nward",FL_ALT+'n',color_cb,(void *)&seis, 0},
  {"O&r upward",FL_ALT+'r',color_cb,(void *)&siete, 0},
  {"And do&wnward",FL_ALT+'w',color_cb,(void *)&ocho, 0},
  {"And upw&ard",FL_ALT+'a',color_cb,(void *)&nueve, 0},
  {"Hide color",0,color_cb,(void *)&diez, 0},
  {"Unhide all",0,color_cb,(void *)&once, 0},
  {0},
  {"Tid&y",FL_ALT+'y',tidy_cb,0,0},
  {"A&lign",FL_ALT+'l',align_cb,0,0},
  {"A&nnealing",FL_ALT+'N',simanneal_cb,0,0},
  {"&Wipe labels",FL_ALT+'W',wipe_cb,0,0},
  {0},
  {"&Motion",0,0,0, FL_MENU_INACTIVE|FL_SUBMENU},
  {"&Free",FL_ALT+'F',grmode_cb, (void *)&cero,FL_MENU_RADIO},
  {"&Horizontal",FL_ALT+'h',grmode_cb, (void *)&uno,FL_MENU_RADIO|FL_MENU_VALUE},
  {"&Vertical",FL_ALT+'v',grmode_cb, (void *)&dos ,FL_MENU_RADIO},
  {"&Rounding",FL_ALT+'R',grmode_cb, (void *)&tres ,FL_MENU_RADIO},
  {0},
  {0}
};


Fl_Input *indx;
Fl_Input *nme;
Fl_Input *lbl;

void txt2pedc_cb(Fl_Widget *wm, void *){

  if(!(pedcopen=txt2pedc_it(pedname))) return;
  int i;
  FILE *file;
  if((file = fopen(pedname,"w")) == NULL){
    fl_alert(" Unable to open %s ",pedname);
    return;
  }
  outputpedc(file,pedname,0);
  fclose(file);
  ymax = 1.0 - 0.27/higen;
  ymin = 0.07/higen;

  Fl_Menu_Item *w = &maintable[1];
  w->deactivate();
  w = w->next();
  w->deactivate();
  w = &maintable[6];
#ifndef WIN32
  for(i=0; i<6; i++){
#else
  for(i=0; i<5; i++){
#endif
    w->activate();
    w = w->next();
  }
#ifndef WIN32
  w = &maintable[14];
#else
  w = &maintable[13];
#endif
  w->activate();
#ifndef WIN32
  w = &maintable[36];
#else
  w = &maintable[35];
#endif
  w->activate();
  d->show();
  d->redraw();
  wm->redraw();
}


void openpedc(int ppk){
  FILE *file;
  if ( (file = fopen(pedname,"r")) == NULL ) {
    fl_alert("Cannot open %s", pedname);
    pedcopen=false; return;
  }

  int pedco = inputpedc(file,ppk); 
  fclose(file);

  if (!pedco) {
    fl_alert("File error: %s is not in correct format", pedname);
    pedcopen = false; return;
  }else
    pedcopen = true;

  if (pedco>1)
    fl_alert("Warning: information on %d trai%s has been dropped", 
	     pedco-1, pedco>2 ? "ts" : "s");

  int i;
  for (i=1; i<=marpt; i++) marstack[i].info.flag = UP;
  for (i=1; i<=indpt; i++) indstack[i].info.flag = UP;

  ymax = 1.0 - 0.27/higen;
  ymin = 0.07/higen;

  Fl_Menu_Item *w = &maintable[1];
  w->deactivate();
  w = w->next();
  w->deactivate();
  w = &maintable[6];
#ifndef WIN32
  for(i=0; i<6; i++){
#else
  for(i=0; i<5; i++){
#endif
    w->activate();
    w = w->next();
  }
#ifndef WIN32
  w = &maintable[14];
#else
  w = &maintable[13];
#endif
  w->activate();
#ifndef WIN32
  w = &maintable[36];
#else
  w = &maintable[35];
#endif
  w->activate();
  d->show();
  d->redraw();
}

#include <FL/Fl_Input.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Return_Button.H>
#include <FL/Fl_Box.H>

extern const char *fl_ok;
extern const char *fl_cancel;

class SimAnneal : public Fl_Window{
  Fl_Box *tit[2];
public:
  Fl_Input *we[7];
  Fl_Output *ev[4];
  Fl_Output *wee;
  Fl_Button *ok_;
  Fl_Button *cancel_;
  SimAnneal();
};

SimAnneal::SimAnneal() : Fl_Window(400,350){
  begin();
  tit[1] = new  Fl_Box(250,5,100,25,"weight");
  tit[0] = new  Fl_Box(100,5,100,25,"energy"); 
  we[0] = new Fl_Input(250,30,100,25);
  we[0]->value("0.01");
  we[1] = new Fl_Input(250,60,100,25);
  we[1]->value("0.01");
  we[2] = new Fl_Input(250,90,100,25);
  we[2]->value("100.0");
  we[3] = new Fl_Input(250,120,100,25);
  we[3]->value("25.0");
  we[6] = new  Fl_Input(175,210,100,25,"iterations");
  we[6]->value("1000");
  we[4] = new  Fl_Input(175,250,100,25,"initial temperature");
  we[4]->value("20.0");
  we[5] = new  Fl_Input(175,280,100,25,"cooling factor");
  we[5]->value("0.95");
  ok_ = new Fl_Return_Button(230,320,100,25, fl_ok);
  cancel_ = new Fl_Button(70,320,100,25, fl_cancel);
  ev[0] = new Fl_Output(100,30,130,25,"expansion:");
  ev[1] = new Fl_Output(100,60,130,25,"contraction:");
  ev[2] = new Fl_Output(100,90,130,25,"edges:");
  ev[3] = new Fl_Output(100,120,130,25,"sibship:");
  wee = new Fl_Output(180,160,100,25,"weighted energy:");

  end();
  set_modal();
}

#include <sstream>

void simanneal_it(){
  int i;
  float ee[6], wgte;
  static SimAnneal *sa;
  if(!sa) sa = new SimAnneal;
  sa->ok_->label(fl_ok);
  sa->cancel_->label(fl_cancel);
  energies(ee[0],ee[1],ee[2],ee[3]);
  for(i=0; i<4; i++){
      ostringstream foo;
      foo << ee[i] << ends;
      sa->ev[i]->value((foo.str()).c_str());
  }
  sa->show();
  int ok=0;
  
  do{
    Fl::wait();
    Fl_Widget *o = Fl::readqueue();
    wgte = 0;
    for(i=0; i<4; i++)
	wgte +=  ee[i]*atof(sa->we[i]->value());
    ostringstream foo;
    foo << wgte << ends;
    sa->wee->value((foo.str()).c_str());
    if(o == sa->ok_){ ok = 1; break;}
    if(o == sa->cancel_) break;
  }while(1);
  sa->hide();
  if(ok){
    bckpcoords bak;
    bak.copy();
    for(i=0; i<6; i++)
      ee[i] = atof(sa->we[i]->value());
    i = atoi(sa->we[6]->value());
    simanneal(i,ee[4],ee[5],ee[1],ee[0],ee[2],ee[3]);

    d->hide();
    d->show();
    if(!fl_choice("Do you like it?","No","Yes",0L))
	bak.unset();
  }
  d->hide();
  d->show();
}

void cb_index(Fl_Widget *co){
  int _idx = atoi(((Fl_Input *)co)->value());
  int i = indpt;
  do{
    if(_idx == indstack[i].info.name){
      pinkish = i;
      d->hide();
      d->show();
      return;
    }
  }while(--i);
  fl_alert("Sorry. Index does not exist.");
}

void cb_name(Fl_Widget *co){
  char foo[128];
  strcpy(foo,((Fl_Input *)co)->value());
  int i = indpt;
  do{
    if(strcmp(indstack[i].info.id,foo) == 0){
      pinkish = i;
      d->hide();
      d->show();
      return;
    }
  }while(--i);
  fl_alert("Sorry. Identity does not exist.");
}

void cb_label(Fl_Widget *co);

int main(int argc, char **argv)
{
  int i;
  pedcopen=false;
  flag_cb = 0;
  xmin = 0.02;
  xmax = 0.98;

  if(!Fl::args(argc,argv,i)) Fl::fatal(Fl::help);

  Fl_Window window(610,610,"pfiddler");
  Drawing dra(0,30,610,610);
  Fl_Menu_Bar mainmenu(0,0,310,25); mainmenu.menu(maintable);
  Fl_Input index(312,0,48,25);
  Fl_Input name(362,0,121,25);
  Fl_Input labell(485,0,123,25);

  d = &dra;
  indx = &index;
  nme = &name;
  lbl = &labell;
  indx->when(FL_WHEN_ENTER_KEY);
  nme->when(FL_WHEN_ENTER_KEY);
  lbl->when(FL_WHEN_ENTER_KEY);
  indx->callback(cb_index);
  nme->callback(cb_name);
  lbl->callback(cb_label);
  indx->deactivate();
  nme->deactivate();
  lbl->deactivate();

  if(i < argc){
    strcpy(pedname,argv[i]);
    openpedc(0);
    if(!pedcopen)
      exit(1);
  }
  window.end();  
  window.resizable(&dra);
  window.show(argc,argv);
  return Fl::run();
}
