// txt2pedc.h  -*- C++ -*-

#ifndef __PEDIGREET__H
#define __PEDIGREET__H

#include <cstring>
#include <fstream>
#include <sstream>

class rawpedrecord{
public:
  char *id;
  char *label;
  char *dad;
  char *mom;
  int sex, status;
  rawpedrecord(){
    id = NULL; dad = NULL; mom = NULL; sex =0; status =0; label = NULL;}
  rawpedrecord(char *, char *, char*, int, int, char *);
  void update(char *, char *, char *, int, int, char *);
  rawpedrecord & operator=(rawpedrecord &p){
    update(p.id,p.dad,p.mom,p.sex,p.status,p.label);
    return *this;
  }
  ~rawpedrecord(){
    if(id) delete [] id;
    if(mom) delete [] mom;
    if(dad) delete [] dad;
    if(label) delete [] label;
  }
};


void FixPrecedence(const int n, rawpedrecord *p);
void GetRawPedigree(std::ifstream &in, const int n, rawpedrecord *data);
void PrintRawPedigree(const int n, const rawpedrecord *data);

class pedigree{
  unsigned int Nvec;
  unsigned int Dvec;
public:
  unsigned int N;
  char **id;
  char **label;
  unsigned int *father, *mother;
  int *sex, *status;
  void setup(const unsigned int n=100, unsigned int d=100);
  pedigree(){ setup();}
  pedigree(const unsigned int, const char **, const char **, const char **,
	   const int *, const int *, const char **);
  pedigree(const unsigned int, const rawpedrecord *);
  pedigree(const char *);
  void append(const char *, const char *, const char *, 
	      const int &, const int&, const char *);
  void add(const char *, const unsigned int, const unsigned int,
	   const int, const int, const char *);
  ~pedigree();
  inline const unsigned int operator()(const char *s){
    for(unsigned int i=1; i <= N; i++)
      if(strcmp(s,id[i]) == 0) return i;
    return 0;
  }
};


#endif
